Subject: bug#24400: cp: default to --reflink=auto?

From: Pádraig Brady <[email-masked]>
Date: Sat, 10 Sep 2016 10:55:01 +0100

On 09/09/16 23:54, Paul Eggert wrote:
> Currently 'cp' defaults to not using reflinks, which can be 
> significantly slower on a system that supports file cloning. I expect 
> most users would prefer 'cp' to default to --reflink=auto for spped. 
> Although there are some special cases otherwise, on balance how about if 
> we change cp to default to --reflink=auto, and add an option 
> --reflink=no for users who prefer the current default?

Up until now we didn't do that so that we actually get a data copy.
I.E. traditionally such copies were more resilient to partial hardware failures.
However depending on the underlying hardware (which may do deduplication)
we're not guaranteed that an actual copy is made.
In discussions with kernel devs about this (in relation to efficient defaults
for copy_file_range), their current thinking is that separate devices are
required to give such guarantees, so reflinking by default is a valid
thing to do.

It might not be an appropriate thing to do in a minor release.
We're due one of those quite soon now, so I'd suggest waiting
a short while before changing?

thanks,
Pádraig